两数之和

题目描述:

给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。

你可以假设每种输入只会对应一个答案。但是,数组中同一个元素不能使用两遍。

示例:

给定 nums = [2, 7, 11, 15], target = 9

因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]

思路:

利用map这种数据结构,可以在时间复杂度为O(n) 的情况下,得出结果

import java.util.HashMap;
import java.util.Map;

public class Son {


    public static void main(String[] args) {
        int[] arr = {2,7,4,1,8,1};
        twoSum(arr,5);
    }

    private static void twoSum(int[] nums,int target) {
        Map<Integer,Integer> numMap = new HashMap<>();
        for (int i = 0; i < nums.length; i++) {
            int twoVal = target - nums[i];
            Integer twoIndex = numMap.get(twoVal);
            if(twoIndex == null){
                numMap.put(nums[i],i);
            }else {
                System.out.println(i+","+ twoIndex);
            }
        }
    }
}

来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/two-sum
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。

原文地址:https://www.cnblogs.com/dongma/p/14214092.html